from ss_parser import SSParser


class BPSeqParser(SSParser):
    def __init__(self):
        super(BPSeqParser, self).__init__()

    def _parse_line(self, line, seq, pairs):
        fields = line.strip().split()
        i, j = int(fields[0]), int(fields[2])
        resi = fields[1]
        seq.append(resi)
        pairs.append((i, j))

    def parse_str(self, input_str):
        seq = []
        pairs = []
        for line in input_str.strip().split('\n'):
            self._parse_line(line, seq, pairs)
        seq = "".join(seq)
        return seq, pairs

    def parse(self, input_file):
        with open(input_file, 'r') as f:
            lines = f.readlines()
        input_str = "".join(lines)
        return self.parse_str(input_str)
