from ss_writer import SSWriter


class BPSeqWriter(SSWriter):
    def __init__(self):
        super(BPSeqWriter, self).__init__()
        self.format = "{:d}\t{:s}\t{:d}\n"

    def write_str(self, data):
        result = []
        seq, pairs, pair_map = self.split_data(data)
        nres = len(seq)
        for i in range(1, nres + 1):
            resname = seq[i - 1]
            j = pair_map[i] if i in pair_map else 0
            result.append(self.format.format(i, resname, j))
        return "".join(result)

    def write(self, data, output):
        result = self.write_str(data)
        fh = self.get_output_handler(output)
        fh.write(result)
