from error import RNA2dError
from ss_parser import SSParser


class CTParser(SSParser):
    def __init__(self):
        super(CTParser, self).__init__()

    def _parse_line(self, line, seq, pairs):
        fields = line.strip().split()
        i, j = int(fields[0]), int(fields[4])
        resi = fields[1]
        if j != 0:
            pairs.append((i, j))
        seq.append(resi)

    def parse_str(self, input_str):
        seq = []
        pairs = []
        lines = input_str.strip().split('\n')
        nres = int(lines[0].split()[0])
        for line in lines[1:(nres+1)]:
            self._parse_line(line, seq, pairs)
        if len(seq) != nres:
            raise RNA2dError('Invalid CT file, the number of residue is inconsistent.')
        seq = "".join(seq)
        return seq, pairs

    def parse(self, input_file):
        with open(input_file, 'r') as f:
            lines = f.readlines()
        return self.parse_str("".join(lines))
