from ss_writer import SSWriter


class CTWriter(SSWriter):
    def __init__(self):
        super(CTWriter, self).__init__()
        self.format = format("{:d}\t{:s}\t{:d}\t{:d}\t{:d}\t{:d}\n")

    def write_str(self, data):
        result = []
        name = self.get_name(data)
        seq, pairs, pair_map = self.split_data(data)
        nres = len(seq)
        result.append("{:d} {:s} ---Generated by 2dRNA---\n".format(nres, name))
        for i in range(1, nres + 1):
            resname = seq[i - 1]
            prev_i = i - 1 if i >= 1 else 0
            next_i = i + 1 if i <= nres - 1 else 0
            j = pair_map[i] if i in pair_map else 0
            result.append(self.format.format(i, resname, prev_i, next_i, j, i))
        return "".join(result)

    def write(self, data, output):
        fh = self.get_output_handler(output)
        output_str = self.write_str(data)
        fh.write(output_str)
