from helper import get_file_ext
from rna import RNA
from ss_transformer import SSTransformer


class Formatter(object):
    def __init__(self, args):
        self.args = args
        self.no_pk = args.no_pk
        self.formats = RNA.ss_formats
        self.ss_file = args.ss_file
        self.ss_fmt = self._get_ss_fmt()
        if self.ss_fmt == 'di':
            self.seq_file = args.seq_file
            if not self.seq_file:
                raise Exception('the sequence file is needed when the input is in DI format')
        self.out_fmt = args.out_fmt
        self.output = args.output

    def _get_ss_fmt(self):
        if self.args.ss_fmt:
            return self.args.ss_fmt
        else:
            return get_file_ext(self.ss_file)

    def format(self):
        if hasattr(self, 'seq_file'):
            transformer = SSTransformer(input_file=self.ss_file,
                                        input_fmt=self.ss_fmt,
                                        seq_file=self.seq_file,
                                        no_pk=self.no_pk)
        else:
            transformer = SSTransformer(input_file=self.ss_file,
                                        input_fmt=self.ss_fmt,
                                        no_pk=self.no_pk)
        transformer.write(self.output, self.out_fmt)
