import sys
from abc import abstractmethod

from writer import Writer


class SSWriter(Writer):
    def __init__(self):
        super(SSWriter, self).__init__()

    def split_data(self, data):
        assert 'seq' in data
        assert 'pairs' in data
        seq = data['seq']
        pairs = data['pairs']
        pair_map = dict()
        for pair in pairs:
            if len(pair) == 2:
                resi, resj = pair
            else:
                resi, resj, _ = pair
            pair_map[resi] = resj
            pair_map[resj] = resi
        return seq, pairs, pair_map

    def get_name(self, data):
        if 'name' in data:
            name = data['name']
        else:
            name = 'Unknown'
        return name

    def __del__(self):
        if hasattr(self, 'fh') and self.fh and self.fh != sys.stdout:
            self.fh.close()

    @abstractmethod
    def write_str(self, data):
        pass

    @abstractmethod
    def write(self, data, output):
        pass

