from di_filter import DIFilter
from error import RNA2dError
from formatter import Formatter
from performance import Perf
from ss_expander import SSExpander


class SubCommand(object):
    @staticmethod
    def fold(args):
        from factory import Factory
        try:
            folder = Factory.make_folder(args)
            folder.run()
        except RNA2dError as e:
            print(e)

    @staticmethod
    def format(args):
        fmter = Formatter(args)
        fmter.format()

    @staticmethod
    def expand(args):
        p = SSExpander(args)
        p.run()
        p.write()

    @staticmethod
    def filter(args):
        f = DIFilter(args)
        f.run()
        f.write()

    @staticmethod
    def bench(args):
        try:
            bencher = Perf(args)
            bencher.bench()
        except RNA2dError as e:
            print(e)
